function [cs gs tr] = SweepUp(cs,gs,tr,trhs1,trhs2)

if nargin<5
    trhs2 = trhs1;
end

if min(sign(cs(:))).*max(sign(cs(:)))==-1
    cs_sign = 0;
else
    cs_sign = 1;
end

if min(sign(gs(:))).*max(sign(gs(:)))==-1
    gs_sign = 0;
else
    gs_sign = 1;
end

for i=1:length(trhs1)
    fprintf('.');
    for j=1:length(trhs2)
        fprintf('-.');
        sel = find(tr(1,:)==trhs1(i) & tr(2,:)==trhs2(j));
        if i<length(trhs1)
            sel1 = find(tr(1,:)==trhs1(i+1) & tr(2,:)==trhs2(j));
            [a1 b1] = ISA_v3a_silent(cs(:,sel),trhs1(i+1),trhs2(j),[],cs_sign,gs_sign);
            if size(b1,2)>0
                C1 = corrz(gs(:,sel1),b1);
                if ~isempty(C1)
                    seli = find(max(C1,1)<.95);
                    cs = [cs a1(:,seli)];
                    gs = [gs b1(:,seli)];
                    tr = [tr repmat([trhs1(i+1);trhs2(j)],1,length(seli))];
                else
                    cs = [cs a1];
                    gs = [gs b1];
                    tr = [tr repmat([trhs1(i+1);trhs2(j)],1,size(a1,2))];
                end
            end
        end
    end
    fprintf('\n|');

    for j=1:length(trhs2) 
        sel = find(tr(1,:)==trhs1(i) & tr(2,:)==trhs2(j));
        fprintf(' |');
        if j<length(trhs2)
            sel2 = find(tr(1,:)==trhs1(i) & tr(2,:)==trhs2(j+1));
            [a2 b2] = ISA_v3a_silent(cs(:,sel),trhs1(i),trhs2(j+1),[],cs_sign,gs_sign);
            if size(b2,2)>0
                C2 = corrz(gs(:,sel2),b2);
                if ~isempty(C2)
                    seli = find(max(C2,1)<.95);
                    cs = [cs a2(:,seli)];
                    gs = [gs b2(:,seli)];
                    tr = [tr repmat([trhs1(i);trhs2(j+1)],1,length(seli))];
                else
                    cs = [cs a2];
                    gs = [gs b2];
                    tr = [tr repmat([trhs1(i);trhs2(j+1)],1,size(a2,2))];
                end                    
            end
        end
    end
    fprintf('\n');
end
fprintf('.')
for j=1:length(trhs2)
    fprintf('-.')
end
fprintf('\n');