function [scores] = signature6d(data, w, threshold)
% finds those columns where the subset of 'data' deviates significantly from the average

% INPUT:
% data:      double matrix - contains the data to be analyzed
% weights:   double matrix - each column assigns a set of weights for the rows
% threshold: double scalar - defines the thresholds for sigificance
%
% OUTPUT:
% scores:  double matrix - each row contains the weights assigned for the columns

% get dimensions:
% [data_rows, data_cols] = size(data);

% multiply each data element by the relevant score
% scores = (data * w);

% find significant entries (normalized deviation > 'threshold')

% me = mean(scores);
% weight_squares_sums = eps + sum(w .^ 2);
% sd = sqrt(weight_squares_sums / data_cols);

% sg = (scores > repmat(ups, data_rows, 1) | scores < repmat(dws, data_rows, 1)); 

% return the weighted average of the data that is above threshold
% weight_sums = eps + sum(w.^2);
% scores = (scores .* significance) ./ repmat(weight_sums, data_rows, 1);
%%
scores = ISA_multiply(data,w);

% [me sd] = meanstd(scores);
% ups = me + threshold * sd;
% dws = me - threshold * sd;
% 
% sg = sparse(size(scores,1),size(scores,2));
% for j=1:size(scores,2)
%     sg(:,j) = scores(:,j)>ups(j) | scores(:,j)<dws(j);
% end

ups = prctile(scores,100*threshold,1);
dws = prctile(scores,100*(1-threshold),1);

% scores = scores.*(((scores<repmat(tr2,size(scores,1),1)) +...
% (scores>repmat(tr1,size(scores,1),1)))~=0);

sg = sparse(size(scores,1),size(scores,2));
for j=1:size(scores,2)
    sg(:,j) = scores(:,j)>ups(j) | scores(:,j)<dws(j);
end

scores = (scores .* sg);
scores = scores./ repmat(max(scores), size(scores,1), 1);
