clear all
clc
load nci60_data_fragment

%% Data normalization
global data1 data1T data2 data2T
data1 = normalize(normalize(G,1),2);
data1T = normalize(G,1)';
data2 = normalize(normalize(D,1),2);
data2T = normalize(D,1)';


%% Setting thresholds, number of seeds, signs, etc.
tests = 10;
trh0s = 1:1:3;
trh1s = 1:1:3;
trh2s = 1:1:3;
signs = [0 0 0];

%% initializing output vectors
cs = [];
gs = [];
ds = [];
tr = [];

%% looping over different thresholds

for i=1:length(trh1s)
    for j=1:length(trh2s)
        for k=1:length(trh0s)
            trh = [trh0s(k);trh1s(i);trh0s(k);trh2s(j)];
            
            [a, b, c] = ping_pong_v7(tests,trh,signs,1); % the ping-pong algorithm
            
            cs = [cs a];
            gs = [gs b];
            ds = [ds c];
            tr = [tr repmat([trh0s(k);trh1s(i);trh2s(j)],1,size(a,2))];
            
        end
        
        %% keeping only one representative of modules with similar gene scores
        if size(gs,2)>1000
            C = corrcoef(gs);
            C = (abs(C)>=.9);
            C = tril(C,0);
            selb = find(sum(C,1)==1);
            cs = cs(:,selb);
            gs = gs(:,selb);
            ds = ds(:,selb);   
            tr = tr(:,selb);
        end
    end
end

C = corrcoef(gs);
C = (abs(C)>=.9);
C = tril(C,0);
selb = find(sum(C,1)==1);
cs = cs(:,selb);
gs = gs(:,selb);
ds = ds(:,selb);   
tr = tr(:,selb);

%% Sweeping
[cs gs ds tr] = SweepDownPP(cs,gs,ds,tr,trh0s,trh1s,trh2s,1);
[cs gs ds tr] = SweepUpPP(cs,gs,ds,tr,trh0s,trh1s,trh2s,1);

%% Final pruning
C1 = corrcoef(gs);
C = (abs(C1)>=.9);
C = triu(C,0);
sel = find(sum(C,1)==1);
gs = gs(:,sel);
cs = cs(:,sel);
ds = ds(:,sel);
tr = tr(:,sel);


